<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class PaisRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function validaRestricaoChavePrimaria($cdPais, $nmpais, $isNew) {
        
        $tpvalidacao;
        
        if($isNew)
            $tpvalidacao = ' WHERE (CDPAIS = :CDPAIS OR NMPAIS = :NMPAIS) ';
        else
            $tpvalidacao = ' WHERE CDPAIS <> :CDPAIS AND NMPAIS = :NMPAIS ';
        
        $query = "
                SELECT 
                    COUNT(*)
                FROM PAIS".$tpvalidacao
        ;

        
        $parameters = 
        [
            "CDPAIS"       => $cdPais,
            "NMPAIS"       => $nmpais,
        ];
        $result = $this->connection->fetchAssoc($query, $parameters);

        if($result['COUNT(*)'] > 0) 
            return true;
        else
            return false;
    }

    public function validaExistenciaEstado($cdPais) {
        
        $query = "
                SELECT 
                    COUNT(*)
                FROM 
                    ESTADO
                WHERE
                    CDPAIS = :CDPAIS";

        $parameters = 
        [
            "CDPAIS"    => $cdPais,
        ];
        
        $result = $this->connection->fetchAssoc($query, $parameters);

        if($result['COUNT(*)'] > 0) 
            return true;
        else
            return false;
    }

} 

 