<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 30/06/2016
 * Time: 17:30
 */

namespace HCM\Geral\Services;

use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Events\PreDispatch\Listener;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\Session\Session;

class RequestListener extends Listener {

    /**
     * @var \Zeedhi\Framework\HTTP\Kernel Kernel
     */
    private $httpKernel;
    private $sessionManager;
    private $hcmParameters;

    private $auditRoutes;

    public function __construct(Kernel $kernel, Session $sessionManager, $tempDirectory, $httpInterface, $projectVersion){
        $this->httpKernel = $kernel;
        
        $this->sessionManager = $sessionManager;
        $this->tempDirectory = $tempDirectory;
        $this->httpInterface = $httpInterface;
        $this->projectVersion = $projectVersion;
        
        $this->auditRoutes = $this->readRoutes();
    }

    private function readRoutes(){
        $urls = file_get_contents("../config/auditRoutesMapping.json");
        return json_decode($urls, true);
    }

    public function preDispatch(Request $request)
    {
        try {
            if (in_array($request->getRoutePath(), $this->auditRoutes)) {
                if (get_class($request) == 'Zeedhi\Framework\DTO\Request\DataSet') {
                    foreach ($request->getDataSet()->getRows() as &$row) {
                        $this->setCamposAuditoria($row);
                    }
                }
            }
        }catch (\Exception $e){
            throw new \Exception($e->getMessage());
        }
    }

    private function setCamposAuditoria(&$row)
    {
        if(!isset($row['__is_new']))
            return;
        if($row['__is_new'] === true){
            $row['DTINCLUSAO'] = date('d/m/Y H:i:s');
            $row['DTULTATU'] = date('d/m/Y H:i:s');
            $row['NRORGINCLUSAO'] = FPA::getNrorgTrabalho();
            $row['NRORGULTATU'] = FPA::getNrorgTrabalho();
            $row['CDOPERINCLUSAO'] = FPA::getCdoperador();
            $row['CDOPERULTATU'] = FPA::getCdoperador();
        } else if($row['__is_new'] === false){
            $row['DTULTATU'] = date('d/m/Y H:i:s');
            $row['NRORGULTATU'] = FPA::getNrorgTrabalho();
            $row['CDOPERULTATU'] = FPA::getCdoperador();
        }
    }
}