/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLASSECIA                                                */
/* Tabela : CLASSECIA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CLASSECIA
BEFORE INSERT OR UPDATE OR DELETE
ON CLASSECIA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCLAC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DSCLASSECIA,0) <> NVL(:NEW.DSCLASSECIA,0)) OR
         (NVL(:OLD.CDCLASSE,0)    <> NVL(:NEW.CDCLASSE,0)) THEN
         :NEW.DTULTATUCLAC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CLASSECIA', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDCIA='||:OLD.CDCIA||';CDCLASSE='||:OLD.CDCLASSE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CLASSECIA MODIFY DTULTATUCLAC DEFAULT SYSDATE
/
