/*
   DESCCRIO: PROCEDIMENTO PARA VERIFICAR SE  POSSIVEL ENCAIXAR
               A PRODUO DE UM PRODUTO NOS LOTES QUE J FORAM CRIADOS
               NO MRP.
Criao: Welbert G. Moitinha
Data: 25/06/2010

*/

CREATE OR REPLACE PROCEDURE VERIFICA_SALDO_LOTE_PROD(  P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
                                                       P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE,
                                                       P_DTMRP IN DATE,
                                                       P_DTPRODUCAO IN DATE,
                                                       P_QTAFABRICDIA IN FLOAT,
                                                       P_GERACALE OUT VARCHAR2)

IS
   V_SALDO FLOAT;
   V_QTAFABRICDIA FLOAT;
BEGIN

   V_QTAFABRICDIA := P_QTAFABRICDIA;
   V_SALDO := 0;

   BEGIN
      SELECT
             SUM(NVL(C.QTAFABRICMRP,0)) - SUM( NVL(C.QTAFABRICDIA,0))
        INTO V_SALDO
        FROM
             CALEPRODMRP C, PROCFABRICA P
       WHERE
             C.CDFILIAL = P_CDFILIAL  AND
             C.CDPRODUTO = P_CDPRODUTO AND
             C.DTPROGPRODCP = P_DTMRP AND
             TRUNC(C.DTCONCPROMRP) = TRUNC(P_DTPRODUCAO) AND
             P.CDFILIAL = C.CDFILIAL AND
             P.CDPRODUTO = C.CDPRODUTO AND
             IDPROFABPADR = 'S';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_SALDO := 0;
         P_GERACALE := 'S';
      END;


   IF (V_SALDO >= V_QTAFABRICDIA) THEN
      FOR C_REG IN ( SELECT C.CDFILIAL,
                            C.NRSEQLOTEDIA,
                            C.CDPRODUTO,
                            C.QTAFABRICDIA,
                            C.QTAFABRICMRP,
                            P.QTPADPROCFAB
                         FROM
                            CALEPRODMRP C, PROCFABRICA P
                         WHERE
                            C.CDFILIAL = P_CDFILIAL  AND
                            C.CDPRODUTO = P_CDPRODUTO AND
                            C.DTPROGPRODCP = P_DTMRP AND
                            C.DTCONCPROMRP = P_DTPRODUCAO AND
                            P.CDFILIAL = C.CDFILIAL AND
                            P.CDPRODUTO = C.CDPRODUTO AND
                            IDPROFABPADR = 'S'   )LOOP

         IF ((C_REG.QTAFABRICMRP - C_REG.QTAFABRICDIA) >= V_QTAFABRICDIA)AND (V_QTAFABRICDIA > 0) THEN

            UPDATE CALEPRODMRP
            SET QTAFABRICDIA = QTAFABRICDIA + V_QTAFABRICDIA
            WHERE
               (CDFILIAL     = P_CDFILIAL)             AND
               (DTPROGPRODCP = P_DTMRP)                AND
               (CDPRODUTO    = P_CDPRODUTO)  AND
               (DTCONCPROMRP = P_DTPRODUCAO) AND
               (NRSEQLOTEDIA = C_REG.NRSEQLOTEDIA);
            V_QTAFABRICDIA := 0;
         END IF;
      END LOOP;
      P_GERACALE := 'N';
   ELSE
      P_GERACALE := 'S';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('VERIFICA_SALDO_LOTE_PROD','5.05.016'); END;
/


